unit Unit4; 

{$mode objfpc}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids;

type

  { TFormASCII }

  TFormASCII = class(TForm)
    StringGridASCII: TStringGrid;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormASCII: TFormASCII; 
  i,j,k,l:   Byte;
  zk:        String;

implementation

{ TFormASCII }

procedure TFormASCII.FormCreate(Sender: TObject);
begin
  For i:=0 to 255 Do                                                            // leider nur ASCII
    Begin
      StringGridASCII.Cells[0,i+1]:=FormatFloat('000',i);

//      Str(i,zk); j:=Length(zk); Val(zk,k,l);                                    // Versuch ANSI
//      ShowMessage('zk - Länge: '+IntToStr(j)+'   Inhalt: '+IntToStr(k));

//      zk:=AnsiToUtf8(Chr(i));                                                 // nützt alles nix
//      zk:=SysToUtf8(Char(i));
//      zk:=Utf8ToSys(Char(i));
//      zk:=Utf8ToAnsi(Char(i));
      zk:=AnsiToUtf8(Char(i));
//      zk:=Char(i);
      StringGridASCII.Cells[1,i+1]:=zk;
      If i=255 Then
        Begin
          StringGridASCII.Cells[1,1]  :='NUL';
          StringGridASCII.Cells[1,2]  :='SOH';
          StringGridASCII.Cells[1,3]  :='STX';
          StringGridASCII.Cells[1,4]  :='ETX';
          StringGridASCII.Cells[1,5]  :='EOT';
          StringGridASCII.Cells[1,6]  :='ENQ';
          StringGridASCII.Cells[1,7]  :='ACK';
          StringGridASCII.Cells[1,8]  :='BEL';
          StringGridASCII.Cells[1,9]  :='BS';
          StringGridASCII.Cells[1,10] :='HT';
          StringGridASCII.Cells[1,11] :='LF';
          StringGridASCII.Cells[1,12] :='VT';
          StringGridASCII.Cells[1,13] :='FF';
          StringGridASCII.Cells[1,14] :='CR';
          StringGridASCII.Cells[1,15] :='SO';
          StringGridASCII.Cells[1,16] :='SI';
          StringGridASCII.Cells[1,17] :='DLE';
          StringGridASCII.Cells[1,18] :='DC1';
          StringGridASCII.Cells[1,19] :='DC2';
          StringGridASCII.Cells[1,20] :='DC3';
          StringGridASCII.Cells[1,21] :='DC4';
          StringGridASCII.Cells[1,22] :='NAK';
          StringGridASCII.Cells[1,23] :='SYN';
          StringGridASCII.Cells[1,24] :='ETB';
          StringGridASCII.Cells[1,25] :='CAN';
          StringGridASCII.Cells[1,26] :='EM';
          StringGridASCII.Cells[1,27] :='SUB';
          StringGridASCII.Cells[1,28] :='ESC';
          StringGridASCII.Cells[1,29] :='FS';
          StringGridASCII.Cells[1,30] :='GS';
          StringGridASCII.Cells[1,31] :='RS';
          StringGridASCII.Cells[1,32] :='US';
          StringGridASCII.Cells[1,33] :='SPACE';
          StringGridASCII.Cells[1,128]:='DEL';
          StringGridASCII.Cells[1,130]:='ü';                                    // nicht die "feine englische Art"
          StringGridASCII.Cells[1,133]:='ä';
          StringGridASCII.Cells[1,143]:='Ä';
          StringGridASCII.Cells[1,149]:='ö';
          StringGridASCII.Cells[1,154]:='Ö';
          StringGridASCII.Cells[1,155]:='Ü';
          StringGridASCII.Cells[1,226]:='ß';
        end;
      StringGridASCII.Cells[2,i+1]:=HexStr(i,2);
      StringGridASCII.Cells[3,i+1]:=BinStr(i,8);
    End;
end;

initialization
  {$I Unit4.lrs}

end.

